module ParseTree exposing (..)

import Tree exposing (..)


type ParseTree tt nt
    = Leaf tt
    | EpsilonLeaf
    | Branch nt (List (ParseTree tt nt))


parseTreeToString : ParseTree tt nt -> String
parseTreeToString parseTree =
    case parseTree of
        EpsilonLeaf ->
            "eps"

        Leaf terminal ->
            Debug.toString terminal

        Branch nonterminal list ->
            Debug.toString nonterminal ++ "[" ++ String.join ", " (List.map parseTreeToString list) ++ "]"



-- "  S [T [T, a, T, b], c]"


parseTreeToTreeString : ParseTree tt nt -> Tree String
parseTreeToTreeString parseTree =
    case parseTree of
        EpsilonLeaf ->
            Tree { data = "eps", children = [] }

        Leaf terminal ->
            Tree { data = Debug.toString terminal, children = [] }

        Branch nonterminal childrenParseTrees ->
            Tree { data = Debug.toString nonterminal, children = List.map parseTreeToTreeString childrenParseTrees }
